#ifndef _GIVARO_ZPZ_H_ 
#define _GIVARO_ZPZ_H_ 

#ifndef __DONOTUSE_longlong__
#define __USE_64_bits__
#endif
// ==========================================================================
// $Source: /local/cvs/Givaro/src/kernel/zpz/givzpz.h,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: T. Gautier
// $Id: givzpz.h,v 1.3 2003/04/17 16:50:27 jgdumas Exp $
// ==========================================================================
// Description:
//   Family of arithmetics over Zpz

// ==========================================================================
// -- 
// ==========================================================================
#include <givconfig.h>

template<class TAG>
class ZpzDom {};

// -- Tag for arithmetic:
class Std16 { typedef int16 type;}; // -- standard arithmetic over 16bits representations.
class Std32 {typedef int32 type;}; // -- standard arithmetic over 32bits representations.

class Log16 { typedef int16 type;}; // -- log arithmetic over 16bits representations.

#include "givzpz16std.h"
#include "givzpz16table1.h"
#include "givzpz32std.h"

#ifdef __USE_64_bits__
#define __USE_Givaro_64__
#endif

#ifdef __USE_ISOC99
#define __USE_Givaro_64__
#endif

#ifdef __USE_Givaro_64__
#define __USE_GMPPLUSPLUS_64__
class Std64 {}; // -- standard arithmetic over 64bits representations.
typedef long long int64;
typedef unsigned long long uint64;

#include "givzpz64std.h"
#endif

#include "givzpzInt.h"

#endif
